/* yasep/ASM/YASMed.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org

created 2009-01-23 by yg@yasep.org as tools/listed.js
2009-01-26
2009-01-31
2009-02-01
2009-02-06 : moved most code to the listed object
2009-02-10 : style changes, feedback from St<E9>phane Moriaux etc.
Feb 12 01:07:16 2009 : style changes again
Feb 16 02:34:50 2009
todo : gestion des <E9>v<E9>nements avec seamonkey : souris qui d<E9>tecte pas le rel<E2>chement du bouton
Feb 24 01:30:28 2009 : j'ai 32 ans ! et j'ai r<E9>uni les 2 images de la poubelle en une [:kikiv]
2009-07-07 : moved to tools/
2009-07-11 : new argument to ygwm.new_window
2009-07-22 : column hiding
2009-07-27 : duplicate_listing_row fixed
lun. févr. 13 04:59:42 CET 2012 : YASMed.js
lun. févr. 20 07:07:42 CET 2012 : export VHDL
sam. mars 24 14:01:02 CET 2012 : substitute
jeu. mai 10 04:44:20 CEST 2012 : moved from tool to ASM
mer. août 22 18:33:22 CEST 2012 : adding .org and ErrorLine
jeu. août 23 14:28:47 CEST 2012 : removing some global variables from win and using closures in win.asmctx functions
mar. août 28 01:20:11 CEST 2012 : some cleanup, checking instruction alignment, removing t.error and ErrorLine, making .org more functional, drag&drop of individual lines

Purpose : Create and maintain windows of the iterative assembly editor (derived from listed)

TODO : cleanup the trigger
DONE : prevent export if errors
TODO : better support for CPU profiles
 */

init_obj.push(YASMed={
  header: ";;;;;;;;;;;;;;; end auto header ;;;;;;;;;;;;;;;",
  serial:0,  // must be set by a cookie !!!

  OddEvenArray:["even", "odd"],

  AdjustPClen:function(win){
    if (win.asmctx.name!="" && win.asmctx.core===false && config.core) {
      var t=win.LastAddress,
          i=0;
      while (t>0){ // iterative log2
        i++;
        t>>>=1;
      }
      config.core.PC_length=i;
    }
  },

  reassemble:function(ev, win) {
    win=parentWin(win||this);
    w=impASM.importCode(YASMed.export_ASM(-1,win));
    // overlay the new window over the current one and close the old version
    ygwm.changeDimensions(win.w,win.h,w);
    ygwm.move(w,win.x, win.y);
    ygwm.erase_window(null,win)
  },

  export_ASM:function(ev, win) {
    // if ev==-1 then just return the original source code (see reassemble)
    if (win=parentWin(win||this)) {
      // ok now we have the window. let's generate a header for the new source code
      var h="; "+win.FuncName+generated(";","ASM/YASMed.js"),
          t= win.list_header_id.nextSibling, i,j="";
      if (win.subst.length>0) {
        h+="; Dump of the substitution table :\n";
        for (i in win.subst)
          h+=".subst "+win.subst[i].src+" "+win.subst[i].dst+"\n";
      }
      h+=I8N("nwol")+YASMed.header+"\n";

      // now scan the original window and concatenate all the source code.
      while(t) {
        j+=t.source_id.source+"\n";
        if (t.source_id.source==YASMed.header)
          j=""; // strip the header
        t=t.nextSibling;
      }
      // strip the trailing \n's
      t=j.length-1;
      while(j[t]=="\n")
        t--;
      j=j.slice(0,t+1);

      YASMed.AdjustPClen(win);
      h+=j;
      // commit
      if (ev===-1)
        return h;
      else
        savefile.save(win.FuncName+".yas",h);
    }
  },

  export_HEX:function(ev, win) {
    if (win=parentWin(win||this)) {
      if (win.start_address)
        return Al8N("yalt2"); // ".org is not supported"
      // ok now we have the window. create a header :
      var h=";;yhx0\n;; Dump of "+win.FuncName+generated(";;","ASM/YASMed.js"),
          t= win.list_header_id.nextSibling, i;
      // scan the source code and extract the binary output :
      while(t) {
        if (t.bgCol)
          return Al8N("yalt1"); //"Can't export if the code contains error(s)"
        if(t.bytes)
          for(i in t.bytes_array)
            h+=int2hex( t.bytes_array[i],1,1,1)+" ";
        if(t.source_id.source!="")
          h+="; "+t.source_id.source+"\n";
        t=t.nextSibling;
      }
      YASMed.AdjustPClen(win);
      savefile.save(win.FuncName+".yhx",h);
    }
  },

  export_VHDL:function(ev, win) {
    if (win=parentWin(win||this)) {
      if (win.LastAddress & 1)
        return Al8N("even");
      if (win.start_address)
        return AlrT(YASMed.alrt2); // ".org is not supported"
      if ((typeof win.asmctx.core == "object")
        &&(typeof win.asmctx.core.PC_length == "number")
        &&(win.LastAddress > (1 << win.asmctx.core.PC_length) ))
        return Al8N("sztm");

      var size=win.LastAddress>>1,
          t=win.list_header_id.nextSibling, i, j=0, k;
h="-- Dump of "+win.FuncName
+generated("--","ASM/YASMed.js")
+"Library work;\n"
+"    use work.yasep_definitions.all;\n"
+"    use work.yasep_utils.all;\n"
+"Library ieee;\n"
+"    use ieee.std_logic_1164.all;\n"
+"    use ieee.numeric_std.all;\n"
+"\n"
+"entity SynchRam16 is\n"
+" port(\n"
+"  clk, reset, en: in std_logic := '0';\n"
+"  NPC: in SLVAI;\n"
+"  RAM_out: out SLV16);\n"
+"end SynchRam16;\n"
+"\n"
+"architecture "+win.FuncName+" of SynchRam16 is\n"
+"  signal latched_addr : SLVAI := (SLVAI'range=>'0');\n"
+"  type RAM_array_type is array(0 to "+size+") of SLV16;\n"
+"  constant RAM_array : RAM_array_type := (\n";

      function emit_SLV16(s,k) { // This function handles the mask bits,
        var m='",';              // so it emits "-" when the bit is "don't care"
        for (i=16; i>0; i--) {
          if (k & 1)
            m=(s & 1)+m;
          else
            m='-'+m;
          s>>>=1;
          k>>>=1;
        }
        h+=' "'+ m;
      }

      // Scan the source code and emit the bits
      while(t) {
        if (t.bgCol)
          return AlrT(YASMed.alrt1);
        if(t.bytes) {
          // is it an instruction ?
          if (t.encoded_fields!=0) {
            if (j  // some DB was not completely flushed
               ||(t.address & 1))
              return Alrt("Ierr2","",t.TrLineNr,"inaa");
            emit_SLV16(t.encoded_instruction, t.encoded_fields);
            if (t.bytes > 2)
              emit_SLV16(t.encoded_instruction >>> 16, t.encoded_fields >>> 16);
          }
          else {
            for(i in t.bytes_array) {
              var s=toBin(t.bytes_array[i],8);
              // accumulate 2 successive strings of 8 bits to make a 16-bits word
              // (note: j is initialised to 0 at the beginning of the function)
              if (!j++) // (j++==0)  OOoohh ugly...
                k=s;
              else {
                j=0;
                h+=' "'+s+k+'",';
              }
            }
          }
        }
        if(t.source_id.source!="")
          h+=" -- "+t.source_id.source+"\n";
        t=t.nextSibling;
      }

      YASMed.AdjustPClen(win);

h+=" \"1111111111111111\" );\n"  // Add "INV" because I wouldn't bother removing the last comma, plus the auto-prefetch gets the next word !
+"\n"
+"begin\n"
+"  process(clk, en)\n"
+"  begin\n"
+"    if rising_edge(clk) and en='0' then\n"
+"      latched_addr <= NPC;\n"
+"    end if;\n"
+"  end process;\n"
+"\n"
+"  process(latched_addr ,reset)\n"
+"    variable adr: integer;\n"
+"  begin\n"
+"    if reset/='1' then\n"
+"      RAM_out <= (RAM_out'range=>'0');\n"
+"    else\n"
+"      adr := safe_to_integer(latched_addr);\n"
+"      if adr < 0 or adr >= RAM_array'length then\n"
+"        report \" Accessing instruction beyond limit at \" & integer'image(adr);\n"
+"        RAM_out <= (RAM_out'range=>'1');\n"
+"      else\n"
+"        RAM_out <= RAM_array(adr);\n"
+"      end if;\n"
+"    end if;\n"
+"  end process;\n"
+"end "+win.FuncName+";\n";
      savefile.save(win.FuncName+".vhdl",h);
    }
  },

  // called by AssembleLine and duplicate_listing_row
  // and actually changes TR colors
  // Also catches unaligned instructions
  renumber_lines:function(win,t,n,ad) {
    // param #2 : id of the first TR to modify
    // param #3 : its intended line number;
    // param #4 : byte address

    if (!t // if only win is provided, renumber everything
      ||(t.nextSibling==win.list_header_id)) { // refresh anyway if it's the very first line
      t=win.list_header_id.nextSibling;
      n=0;
      win.start_address_id.innerHTML
        =ad
        =win.start_address
        =0;
      win.erase_msg();
    }

    var p=t.parentNode, u,orgNr=0;

    while (t != null) {
      t.address=ad;

      t.numero_id.innerHTML  // create/update the numbers
        = t.TrLineNr
        = n++;

      u=t.bgCol;
      if(typeof t.org=="number") {
        if (orgNr++>0){
          u="error";
          win.shortmsg(I8N("R")+I8N("o1oa"));
        }
        else {
          if (ad>0){  // Catch .org at wrong line(s)
            u="error";
            win.shortmsg(I8N("R")+I8N("iod"));
          }
          else {
            u="";
            win.start_address_id.innerHTML
              =ad
              =win.start_address
              =t.org;
          }
        }
      }
      else
        // Check instruction alignment :
        if ((u==="")||(u=="unaligned")) { // don't touch other errors
          // recompute alignment in case it was shifted or reassembled
          u="unaligned";
          if (t.encoded_fields && (t.address & 1))  // unaligned opcode
            win.shortmsg(I8N("R")+I8N("ui"));
          else
            u=""; // no error
        }
 
      if (!(t.bgCol=u))
        u=YASMed.OddEvenArray[t.TrLineNr & 1]; // if no error, update the alternating background color
      t.className=u;

      // handle .align
      if (t.align){ // t.align >=1
        t.address_id.innerHTML=ad;
        var m=t.align-1,
            i=t.align-(ad & m);
        ad+=i;
        if (i!=t.bytes) {
          t.bytes
             =t.size_id.innerHTML
             =i;
          t.bytes_array=[];
          while(i--)
            t.bytes_array.push(0);
        }
      }
      else  {
        if (t.bytes>0){
          t.address_id.innerHTML=ad;
          ad+=t.bytes;
        }
        else
          t.address_id.innerHTML="";
      }

      t=t.nextSibling; // go to the next element
    }

    // if the end of the list is reached,
    if (t == null) {
      p.nbElements=n; // update the element count.
      win.LastAddress_id.innerHTML
       =win.LastAddress
         =ad;
    }
  },

  Reassemble_line: function(t){
    var u=t.parentNode;
    YASMed.AssembleLine(parentWin(u),
      u, t.source, u.TrLineNr, u.address);
  },

  MakeRow: function(c) {
    var i,j,k, t=dcE("TR");
    t.onmouseover=YASMed.mouseover_row;
    for (i in c){
      j=dcE("TD");
      k=c[i];
      t[k+'_id']=j;
      j.className=k;
      switch(k) {
        case "plus" :
          j.title=I8N("aanl");
          j.onclick=YASMed.duplicate_listing_row; // adapter plus tard
          break;
        case "numero" :
          j.title=I8N("mudt");
          dragndrop.register(j, YASMed.dndRow, t);
          break;
        case "source":
          edit_text.register(j,
            { size:60, maxsize:200, func:YASMed.Reassemble_line });
      }
      t.appendChild(j);
    }
    return t;
  },

//  NewSym: function(win,s) {
//    return YASMed.MakeRow(["numero","symval","symname","symtype", "symcomm","symdef","symused"]);
//  },


// Called by NewLine, click->Reassemble_line, FirstLine, duplicate_listing_row
  AssembleLine: function(win, t, s, n, ad) {
// win : window
// t : tr / row of the table
// s : source code
// n : line number
// ad : address of the instruction's first byte
// Returns : nothing...

    t.bgCol
      =t.message_id.innerHTML
      =t.value_id.innerHTML
      =t.size_id.innerHTML
      ="";
    t.source_id.source=s;
    t.source_id.innerHTML=s.replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;");
    t.bytes_array=[];
    t.org
      =t.align
      =null;
    t.bytes
      =0;

//// TODO À modifier !!!!!!!!!!!!
    for (var i in win.subst)
      s = s.replace(win.subst[i].rx, win.subst[i].dst);
//// Make a parser that skips pairs of '"'

    function add_message(col,msg){  // message display routine with closure
      t.message_id.innerHTML +='<span style="background-color:'+col+'">&nbsp;</span> '+msg+'<br>';
      if((col=="red")
       ||((col=="orange")&&(t.bgCol!="red")))
        t.bgCol=col;
    }
    win.asmctx.add_message=add_message;

    win.asmctx.emit_bin=
      function(data, size){
        var h="";
        while (size--) { // displays every byte
          t.bytes_array.push(data&255);
          h=int2hex(data&255,1,1,1)+h;
          data>>=8;
        }
        t.value_id.innerHTML+=h+" ";
      };

    if (s.length && s[0]==='.') {
      // preprocessor directive ? get the next word
      s=s.replace(/[;].*/,"");  // remove any trailing comment
      s=s.replace(/\s+/g," ");  // combine multiple spaces
      s=s.replace(/[ ]$/g,"");  // strip trailing garbage
      var i, s2=s.split(" ");

      function parse_parameter2() {
        if (s2.length!=2)
          return add_message("red",I8N("wdf"));

        s2=s2[1];
        if (s2.length > 30)
          return add_message("red",I8N("ns30"));

        // check for non alpha chars
        i=0;
        while (i < s2.length)
          if (alpha_chars[s2[i++]]!==1)
            return add_message("red",'<u>/!\\</u> '+I8N("nac"));
        return s2;
      }

      switch(s2[0]) {
        case ".name": // Get the new name
          s=parse_parameter2();
          if (typeof s!= "string") break;

          // update the values
          ygwm.changeWinTitle(win, 
            win.FuncName=s,
            true);
          break;

        case ".org":
          // check if it's a valid number
          s=parse_parameter2();
          i=str2int(s); // quiet : don't send an error message
          if ((i===null)||(i<0)) {
            add_message("red", I8N("wnf")+' '+s);
            break;
          }
          // redundancy and position checks are relegated to renumber_lines
          t.org=i;
          // force rescan from the beginning of the listing
          t=null;
          break; // trigger renumber_lines but renumber from the very start

        case ".align":
          // check if it's a valid number
          s=parse_parameter2();
          i=str2int(s); // quiet : don't send an error message
          if ((i===null)||(i<1)) {
            add_message("red", I8N("wnf")+' '+s);
            break;
          }
          if (i>512) {
            add_message("red", i+"??? "+I8N("wtf"));
            break;
          }
          if (i&(~i)) {
            add_message("red", i+I8N("np2"));
            break;
          }
          /* alignment is recomputed in renumber_lines */
          t.align=i;
          break;

        case ".profile": // Get the new name
          s=parse_parameter2();
          if (typeof s!= "string") {
            add_message("red",I8N("Bpn"));
            break;
          }
          if (s=="auto") {
            t.message_id.innerHTML+=I8N("oma");
            win.asmctx.core=false;
            break;
          }
          if (typeof profiles[s]!= "object") {
            add_message("red",I8N("pdne"));
            break;
          }
          win.asmctx.core=profiles[s];
          break;

        case ".": // alias for "label"
          s=parse_parameter2();
          if (typeof s!= "string") {
            add_message("red",I8N("Bln"));
            break;
          }
          if ((typeof (i=win.tsbus[s2[1]])=="number")&& (win.subst[i].dst!=ad)){
            t.message_id.innerHTML+=I8N("svkod");
            break;
          }
          s2=[false,s,""+ad];
          // fold !

        case ".subst":
          if (s2.length<2) {
            add_message("red",I8N("Mws"));
            break;
          }
          var tr,dst="";
          if (s2.length<3)
            t.message_id.innerHTML+=I8N("whtw");
          else {
            i=2;
            while(true){
              dst+=s2[i++];
              if (!s2[i])
                break;
              dst+=" ";
            }
          }

          if (dst == s2[1]) { // skip substitution identity
            t.message_id.innerHTML+=I8N("idtt");
            break;
          }
          if (Y.keywords[s2[1].toUpperCase()]===true) { // keyword ?
            add_message("red",I8N("sbkw"));
          }

          (tr=dcE("DIV")).innerHTML="<b>"+s2[1].replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;")
               +"</b> = \"<i>"+dst.replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;")+"\"</i>";
          var o={
            src:s2[1],
            dst:dst,
            rx:new RegExp(s2[1],"g"),
            tr:tr
          };
          win.subst_id.appendChild(tr);
          if (typeof (i=win.tsbus[s2[1]])=="number"){
            win.subst_id.removeChild(win.subst[i].tr);
            win.subst[i]=o;
          }
          else {
            win.tsbus[s2[1]]=win.subst.length;
            win.subst.push(o);
          }
          break;

        default: add_message("red",I8N("ukd"));
      }
    }
    else {
      Y.encode_instruction(s,win.asmctx);
      if (t.bytes=win.asmctx.encoded_size_bytes) {
        t.size_id.innerHTML=t.bytes;
        t.encoded_fields=win.asmctx.encoded_fields;
        t.encoded_instruction=win.asmctx.encoded_instruction;

        // add the instruction to the used list
        if (win.asmctx.name!="" && win.asmctx.core===false)
          config.changeInstruction("true",win.asmctx.name);
      }
    }

    YASMed.renumber_lines(win,t,n,ad);
  },

  listed_id:["plus","numero","address","size","value","source","message"],

  NewLine: function(win,s) {
    var t=YASMed.MakeRow(YASMed.listed_id);
    win.listed_id.appendChild(t);
    YASMed.AssembleLine(win,t,s,win.listed_id.nbElements,win.LastAddress);
  },

  FirstLine: function(ev) {
    var win=parentWin(this),
        t=YASMed.MakeRow(YASMed.listed_id);
    win.listed_id.insertBefore(t,win.list_header_id.nextSibling);
    YASMed.AssembleLine(win,t,"",0,win.start_address);
          // call NewLine instead ?
    return false;
  },

  duplicate_listing_row:function(ev) {
    // this is the id of the <td class="plus">
    var originalTR = this.parentNode,  // the TR
        p=originalTR.parentNode,       // The table
        win=parentWin(p);              // the window

    if (!ev.ctrlKey) { // Duplicate
      // new row:
      var newTR = YASMed.MakeRow(YASMed.listed_id);
      // include the new row in the table (which forces reflow and redraw)
      p.insertBefore(newTR,originalTR.nextSibling);
      YASMed.AssembleLine(win,newTR,
             ev.shiftKey?originalTR.source_id.source:"",
             originalTR.TrLineNr+1, originalTR.address+originalTR.bytes);
          // call NewLine instead ?
    }
    else  // Erase
      YASMed.remove_row(originalTR);
  },

  remove_row: function(tr){
    var w=parentWin(tr); // used after removal
    tr.parentNode.removeChild(tr); // Attention j'enlève l'échelle
    YASMed.renumber_lines(w);
  },

///////////////////////////////////////////////////////////////////////////////////////////

// Drag&Drop of one TR into the same, or a different, listing

// generated by the following code :
//  moved_row_prev_index:null,
//  moved_row_newWin:null,
//  orig_win:null,
//  moved_row_prevSibling:null,

  mousedrop_row:function() {

// TODO : verify that the user drops inside a YASMed window, cancel the move otherwise

    if (YASMed.moved_row_newWin != YASMed.orig_win)
      YASMed.renumber_lines(YASMed.moved_row_newWin); // Rescan everything in case it was .org
    YASMed.renumber_lines(YASMed.orig_win);
  },

  // When the mouse goes over a TR :
  mouseover_row:function(/*ev*/) {
    if ((dragndrop.dragdropstate ==6) && (this != dragndrop.moved_item)) {
      var  newIndex=this,    // "this" is the TR
             parent=this.parentNode,
                win=parentWin(parent);

      // move a row within the same table ?
      if (YASMed.moved_row_newWin == win) {
        // evaluate where it's better to put the row...
        if ((this.TrLineNr  > YASMed.moved_row_prev_index)
        || ((this.TrLineNr == YASMed.moved_row_prev_index)
             &&(this.previousSibling==dragndrop.moved_item)))
          newIndex=this.nextSibling;
      }
      // move from another table/window :
      else  // focus and update moved_row_newWin
        ygwm.focus_window(null,
          YASMed.moved_row_newWin
          =win);

      dragndrop.moved_item=parent.insertBefore(dragndrop.moved_item,newIndex);
      YASMed.moved_row_prev_index = this.TrLineNr;
      return false;
    }
    return true;
  },

  // onmousedown : called by the dnd register function (start_move => this.dnd.ondrag(this.dndroot); )
  start_move_row:function(row) {
    YASMed.orig_win
     =YASMed.moved_row_newWin
     =parentWin(row);
    YASMed.moved_row_prev_index=row.TrLineNr;
    YASMed.moved_row_prevSibling=row.previousSibling;  // there is ALWAYS a previous sibling (the header or colgroups)
    row.className="selected";  // highlight / change the display style
  },

///////////////////////////////////////////////////////////////////////////////////////////

  // Create a new editor window
  start: function() {
    var plus, w, f="function"+YASMed.serial++,
      cont=dcE("DIV");
    cont.innerHTML=import_htmi("ASM/YASMed");
    winman.patchInnerLinks(cont);
    w = ygwm.new_window("YASMed "+f, null, cont,
       600, 450, 120, 60, false, true, true, true, false, "doc_cygr");
    cleanup_table(w.listed_id=getByClass("table_listing","TBODY",cont));
    w.list_header_id=getById("list_header","tr",cont);
    w.listed_id.nbElements=0;
    w.FuncName=f;
    getById("export_asm" ,"input",w).onclick=YASMed.export_ASM;
    getById("export_hex" ,"input",w).onclick=YASMed.export_HEX;
    getById("export_vhdl","input",w).onclick=YASMed.export_VHDL;
    getById("reassemble" ,"input",w).onclick=YASMed.reassemble;
    (plus=getByClass("plus","th",w.list_header_id)).onclick=YASMed.FirstLine;

    (w.start_address_id=getByClass("start_address","SPAN",w)).innerHTML=  w.start_address=
     (w.LastAddress_id =getByClass("last_address", "SPAN",w)).innerHTML=  w.LastAddress=   0;

    w.asmctx=new Y.ASM_context(null, null, true, profiles["YASEP32"]);
         // 20120924 : added the core so the core configurator does not pop up unless we set .profile auto explicitly
    w.subst=[];
    w.tsbus=[]; // reverse substitution
    w.subst_id=getByClass("subst","DIV",w);

    return w;
  },

  init_obj: function(){
    var r=". .NAME .SUBST .PROFILE .ORG .ALIGN".split(" "), i;
    for (i in r)
      Y.keywords[r[i]]=true;

    YASMed.dndRow={
      trashBin:true,
      ondelete:YASMed.remove_row, //trash_row,
      ondrag:YASMed.start_move_row,
      ondrop:YASMed.mousedrop_row,
      state:6
    };

    menu.subMenuItem(menu.list["ASM"],i8n.ne, "ASM/YASMed");
  }
});
